## htslib 1.16+ds

=== Makefile ===
# Makefile for htslib, a C library for high-throughput sequencing data formats.
#
#    Copyright (C) 2013-2022 Genome Research Ltd.
#
#    Author: John Marshall <jm18@sanger.ac.uk>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
# THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
# DEALINGS IN THE SOFTWARE.

CC     = gcc
AR     = ar
RANLIB = ranlib

# Default libraries to link if configure is not used
htslib_default_libs = -lz -lm -lbz2 -llzma -lcurl

CPPFLAGS =
# TODO: make the 64-bit support for VCF optional via configure, for now add -DVCF_ALLOW_INT64
#       to CFLAGS manually, here or in config.mk if the latter exists.
# TODO: probably update cram code to make it compile cleanly with -Wc++-compat
# For testing strict C99 support add -std=c99 -D_XOPEN_SOURCE=600
#CFLAGS   = -g -Wall -O2 -pedantic -std=c99 -D_XOPEN_SOURCE=600
CFLAGS   = -g -Wall -O2 -fvisibility=hidden
EXTRA_CFLAGS_PIC = -fpic
TARGET_CFLAGS =
LDFLAGS  = -fvisibility=hidden
LIBS     = $(htslib_default_libs)

prefix      = /usr/local
exec_prefix = $(prefix)
bindir      = $(exec_prefix)/bin
includedir  = $(prefix)/include
libdir      = $(exec_prefix)/lib
libexecdir  = $(exec_prefix)/libexec
datarootdir = $(prefix)/share
mandir      = $(datarootdir)/man
man1dir     = $(mandir)/man1
man5dir     = $(mandir)/man5
man7dir     = $(mandir)/man7
pkgconfigdir= $(libdir)/pkgconfig

MKDIR_P = mkdir -p
INSTALL = install -p
INSTALL_DATA    = $(INSTALL) -m 644
INSTALL_DIR     = $(MKDIR_P) -m 755
INSTALL_LIB     = $(INSTALL_DATA)
INSTALL_MAN     = $(INSTALL_DATA)
INSTALL_PROGRAM = $(INSTALL)

# Set by config.mk if plugins are enabled
plugindir =

BUILT_PROGRAMS = \
	bgzip \
	htsfile \
	tabix

BUILT_TEST_PROGRAMS = \
	test/hts_endian \
	test/fieldarith \
	test/hfile \
	test/pileup \
	test/pileup_mod \
	test/plugins-dlhts \
	test/sam \
	test/test_bgzf \
	test/test_expr \
	test/test_kfunc \
	test/test_kstring \
	test/test_mod \
	test/test_realn \
	test/test-regidx \
	test/test_str2int \
	test/test_time_funcs \
	test/test_view \
	test/test_index \
	test/test-vcf-api \
	test/test-vcf-sweep \
	test/test-bcf-sr \
	test/fuzz/hts_open_fuzzer.o \
	test/test-bcf-translate \
	test/test-parse-reg \
	test/test_introspection \
	test/test-bcf_set_variant_type

BUILT_THRASH_PROGRAMS = \
	test/thrash_threads1 \
	test/thrash_threads2 \
	test/thrash_threads3 \
	test/thrash_threads4 \
	test/thrash_threads5 \
	test/thrash_threads6 \
	test/thrash_threads7

all: lib-static lib-shared $(BUILT_PROGRAMS) plugins $(BUILT_TEST_PROGRAMS) \
     htslib_static.mk htslib-uninstalled.pc

ALL_CPPFLAGS = -I. $(CPPFLAGS)

# Usually htscodecs.mk is generated by running configure or config.status,
# but if those aren't used create a default here.
htscodecs.mk:
	echo '# Default htscodecs.mk generated by Makefile' > $@
	echo 'include $$(HTSPREFIX)htscodecs_bundled.mk' >> $@
	$(srcdir)/hts_probe_cc.sh '$(CC)' '$(CFLAGS) $(CPPFLAGS)' '$(LDFLAGS)' >> $@

srcdir = .
srcprefix =
HTSPREFIX =

HTS_CFLAGS_AVX2 =
HTS_CFLAGS_AVX512 =
HTS_CFLAGS_SSE4 =

include htslib_vars.mk
include htscodecs.mk

# If not using GNU make, you need to copy the version number from version.sh
# into here.
PACKAGE_VERSION := $(shell $(srcdir)/version.sh)

LIBHTS_SOVERSION = 3

# Version numbers for the Mac dynamic library.  Note that the leading 3
# is not strictly necessary and should be removed the next time
# LIBHTS_SOVERSION is bumped (see #1144 and
# https://developer.apple.com/library/archive/documentation/DeveloperTools/Conceptual/DynamicLibraries/100-Articles/DynamicLibraryDesignGuidelines.html#//apple_ref/doc/uid/TP40002013-SW23)
MACH_O_COMPATIBILITY_VERSION = 3.1.16
MACH_O_CURRENT_VERSION = 3.1.16

# $(NUMERIC_VERSION) is for items that must have a numeric X.Y.Z string
# even if this is a dirty or untagged Git working tree.
NUMERIC_VERSION := $(shell $(srcdir)/version.sh numeric)

# Force version.h to be remade if $(PACKAGE_VERSION) has changed.
version.h: $(if $(wildcard version.h),$(if $(findstring "$(PACKAGE_VERSION)",$(shell cat version.h)),,force))

version.h:
	echo '#define HTS_VERSION_TEXT "$(PACKAGE_VERSION)"' > $@

print-version:
	@echo $(PACKAGE_VERSION)

show-version:
	@echo PACKAGE_VERSION = $(PACKAGE_VERSION)
	@echo NUMERIC_VERSION = $(NUMERIC_VERSION)

config_vars.h:
	echo '#define HTS_CC "$(CC)"' > $@
	echo '#define HTS_CPPFLAGS "$(CPPFLAGS)"' >> $@
	echo '#define HTS_CFLAGS "$(CFLAGS)"' >> $@
	echo '#define HTS_LDFLAGS "$(LDFLAGS)"' >> $@
	echo '#define HTS_LIBS "$(LIBS)"' >> $@

.SUFFIXES: .bundle .c .cygdll .dll .o .pico .so

.c.o:
	$(CC) $(CFLAGS) $(TARGET_CFLAGS) $(ALL_CPPFLAGS) -c -o $@ $<

.c.pico:
	$(CC) $(CFLAGS) $(TARGET_CFLAGS) $(ALL_CPPFLAGS) $(EXTRA_CFLAGS_PIC) -c -o $@ $<


LIBHTS_OBJS = \
	kfunc.o \
	kstring.o \
	bcf_sr_sort.o \
	bgzf.o \
	errmod.o \
	faidx.o \
	header.o \
	hfile.o \
	hts.o \
	hts_expr.o \
	hts_os.o\
	md5.o \
	multipart.o \
	probaln.o \
	realn.o \
	regidx.o \
	region.o \
	sam.o \
	synced_bcf_reader.o \
	vcf_sweep.o \
	tbx.o \
	textutils.o \
	thread_pool.o \
	vcf.o \
	vcfutils.o \
	cram/cram_codecs.o \
	cram/cram_decode.o \
	cram/cram_encode.o \
	cram/cram_external.o \
	cram/cram_index.o \
	cram/cram_io.o \
	cram/cram_stats.o \
	cram/mFILE.o \
	cram/open_trace_file.o \
	cram/pooled_alloc.o \
	cram/string_alloc.o \
	$(HTSCODECS_OBJS) \
	$(NONCONFIGURE_OBJS)

# Without configure we wish to have a rich set of default figures,
# but we still need conditional inclusion as we wish to still
# support ./configure --disable-blah.
NONCONFIGURE_OBJS = hfile_libcurl.o

PLUGIN_EXT  =
PLUGIN_OBJS =

cram_h = cram/cram.h $(cram_samtools_h) $(header_h) $(cram_structs_h) $(cram_io_h) cram/cram_encode.h cram/cram_decode.h cram/cram_stats.h cram/cram_codecs.h cram/cram_index.h $(htslib_cram_h)
cram_io_h = cram/cram_io.h $(cram_misc_h)
cram_misc_h = cram/misc.h
cram_os_h = cram/os.h $(htslib_hts_endian_h)
cram_samtools_h = cram/cram_samtools.h $(htslib_sam_h)
cram_structs_h = cram/cram_structs.h $(htslib_thread_pool_h) $(htslib_cram_h) cram/string_alloc.h cram/mFILE.h $(htslib_khash_h)
cram_open_trace_file_h = cram/open_trace_file.h cram/mFILE.h
bcf_sr_sort_h = bcf_sr_sort.h $(htslib_synced_bcf_reader_h) $(htslib_kbitset_h)
header_h = header.h cram/string_alloc.h cram/pooled_alloc.h $(htslib_khash_h) $(htslib_kstring_h) $(htslib_sam_h)
hfile_internal_h = hfile_internal.h $(htslib_hts_defs_h) $(htslib_hfile_h) $(textutils_internal_h)
hts_internal_h = hts_internal.h $(htslib_hts_h) $(textutils_internal_h)
hts_time_funcs_h = hts_time_funcs.h
sam_internal_h = sam_internal.h $(htslib_sam_h)
textutils_internal_h = textutils_internal.h $(htslib_kstring_h)
thread_pool_internal_h = thread_pool_internal.h $(htslib_thread_pool_h)

# To be effective, config.mk needs to appear after most Makefile variables are
# set but before most rules appear, so that it can both use previously-set
# variables in its own rules' prerequisites and also update variables for use
# in later rules' prerequisites.

# If your make doesn't accept -include, change this to 'include' if you are
# using the configure script or just comment the line out if you are not.
-include config.mk

# Usually config.h is generated by running configure or config.status,
# but if those aren't used create a default config.h here.
config.h:
	echo '/* Default config.h generated by Makefile */' > $@
	echo '#ifndef _XOPEN_SOURCE' >> $@
	echo '#define _XOPEN_SOURCE 600' >> $@
	echo '#endif' >> $@
	echo '#define HAVE_LIBBZ2 1' >> $@
	echo '#define HAVE_LIBLZMA 1' >> $@
	echo '#ifndef __APPLE__' >> $@
	echo '#define HAVE_LZMA_H 1' >> $@
	echo '#endif' >> $@
	echo '#define HAVE_DRAND48 1' >> $@
	echo '#define HAVE_LIBCURL 1' >> $@
	if [ "x$(HTS_CFLAGS_SSE4)" != "x" ] ; then \
	    echo '#define HAVE_POPCNT 1' >> $@ ; \
	    echo '#define HAVE_SSE4_1 1' >> $@ ; \
	    echo '#define HAVE_SSSE3 1' >> $@ ; \
	    echo '#if defined(HTS_ALLOW_UNALIGNED) && HTS_ALLOW_UNALIGNED == 0' >> $@ ; \
	    echo '#define UBSAN 1' >> $@ ; \
	    echo '#endif' >> $@ ; \
	fi
	if [ "x$(HTS_CFLAGS_AVX2)" != "x" ] ; then \
	    echo '#define HAVE_AVX2 1' >> $@ ; \
	fi
	if [ "x$(HTS_CFLAGS_AVX512)" != "x" ] ; then \
	    echo '#define HAVE_AVX512 1' >> $@ ; \
	fi

# And similarly for htslib.pc.tmp ("pkg-config template").  No dependency
# on htslib.pc.in listed, as if that file is newer the usual way to regenerate
# this target is via configure or config.status rather than this rule.
htslib.pc.tmp:
	sed -e '/^static_libs=/s/@static_LIBS@/$(htslib_default_libs)/;s#@[^-][^@]*@##g' $(srcprefix)htslib.pc.in > $@

# Create a makefile fragment listing the libraries and LDFLAGS needed for
# static linking.  This can be included by projects that want to build
# and link against the htslib source tree instead of an installed library.
htslib_static.mk: htslib.pc.tmp
	sed -n '/^static_libs=/s/[^=]*=/HTSLIB_static_LIBS = /p;/^static_ldflags=/s/[^=]*=/HTSLIB_static_LDFLAGS = /p' $< > $@


lib-static: libhts.a

# $(shell), :=, and ifeq/.../endif are GNU Make-specific.  If you don't have
# GNU Make, comment out the parts of these conditionals that don't apply.
ifneq "$(origin PLATFORM)" "file"
PLATFORM := $(shell uname -s)
endif
ifeq "$(PLATFORM)" "Darwin"
SHLIB_FLAVOUR = dylib
lib-shared: libhts.dylib
else ifeq "$(findstring CYGWIN,$(PLATFORM))" "CYGWIN"
SHLIB_FLAVOUR = cygdll
lib-shared: cyghts-$(LIBHTS_SOVERSION).dll
else ifeq "$(findstring MSYS,$(PLATFORM))" "MSYS"
SHLIB_FLAVOUR = dll
lib-shared: hts-$(LIBHTS_SOVERSION).dll hts-$(LIBHTS_SOVERSION).def hts-$(LIBHTS_SOVERSION).lib
else ifeq "$(findstring MINGW,$(PLATFORM))" "MINGW"
SHLIB_FLAVOUR = dll
lib-shared: hts-$(LIBHTS_SOVERSION).dll hts-$(LIBHTS_SOVERSION).def hts-$(LIBHTS_SOVERSION).lib
else
SHLIB_FLAVOUR = so
lib-shared: libhts.so
endif

BUILT_PLUGINS = $(PLUGIN_OBJS:.o=$(PLUGIN_EXT))

ifneq "$(BUILT_PLUGINS)" ""
plugins: lib-shared
endif
plugins: $(BUILT_PLUGINS)


libhts.a: $(LIBHTS_OBJS)
	@-rm -f $@
	$(AR) -rc $@ $(LIBHTS_OBJS)
	-$(RANLIB) $@

print-config:
	@echo HTS_CFLAGS_AVX2 = $(HTS_CFLAGS_AVX2)
	@echo HTS_CFLAGS_AVX512 = $(HTS_CFLAGS_AVX512)
	@echo HTS_CFLAGS_SSE4 = $(HTS_CFLAGS_SSE4)
	@echo HTS_HAVE_NEON = $(HTS_HAVE_NEON)
	@echo LDFLAGS = $(LDFLAGS)
	@echo LIBHTS_OBJS = $(LIBHTS_OBJS)
	@echo LIBS = $(LIBS)
	@echo PLATFORM = $(PLATFORM)

# The target here is libhts.so, as that is the built file that other rules
# depend upon and that is used when -lhts appears in other program's recipes.
# As a byproduct invisible to make, libhts.so.NN is also created, as it is the
# file used at runtime (when $LD_LIBRARY_PATH includes the build directory).

libhts.so: $(LIBHTS_OBJS:.o=.pico)
	$(CC) -shared -Wl,-soname,libhts.so.$(LIBHTS_SOVERSION) $(LDFLAGS) -o $@ $(LIBHTS_OBJS:.o=.pico) $(LIBS) -lpthread
	ln -sf $@ libhts.so.$(LIBHTS_SOVERSION)

# Similarly this also creates libhts.NN.dylib as a byproduct, so that programs
# when run can find this uninstalled shared library (when $DYLD_LIBRARY_PATH
# includes this project's build directory).

libhts.dylib: $(LIBHTS_OBJS)

=== debian/changelog ===
htslib (1.16+ds-2) unstable; urgency=medium

  * Team Upload.
  * Copy htslib.pc.in also to AUTOPKGTEST_TMP
  * Pass correct upstream version so as to not get the +ds
    non-sense in SOVERSIONS

 -- Nilesh Patra <nilesh@debian.org>  Sat, 01 Oct 2022 11:01:03 +0530

htslib (1.16+ds-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Fix lintian-overrides
  * Fix build options to make sure symbols will remain in library

 -- Andreas Tille <tille@debian.org>  Fri, 30 Sep 2022 11:23:39 +0200

htslib (1.14+ds-1~exp1) experimental; urgency=medium

  * New upstream version
  * Remove constraints unnecessary since buster:
    + libhts3: Drop versioned constraint on python3-pysam in Breaks.

 -- Andreas Tille <tille@debian.org>  Tue, 07 Dec 2021 08:28:36 +0100

=== debian/control ===
Source: htslib
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Charles Plessy <plessy@debian.org>,
           Andreas Tille <tille@debian.org>,
           Michael R. Crusoe <crusoe@debian.org>,
           Steffen Moeller <moeller@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               libbz2-dev,
               libcurl4-gnutls-dev,
               liblzma-dev,
               libssl-dev,
               zlib1g-dev,
	       libdeflate-dev,
               libhtscodecs-dev (>= 1.0)
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/htslib
Vcs-Git: https://salsa.debian.org/med-team/htslib.git
Homepage: https://github.com/samtools/htslib
Rules-Requires-Root: no

Package: libhts3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Replaces: libhts-dev (<< 1.13~)
Breaks: libtabixpp (<< 1.0.0-5~),
        libhts-dev (<< 1.13~),
        samtools (<< 1.13~),
        ivar (<< 1.3.1~)
Description: C library for high-throughput sequencing data formats
 HTSlib is an implementation of a unified C library for accessing common file
 formats, such as SAM (Sequence Alignment/Map), CRAM and VCF (Variant Call
 Format), used for high-throughput sequencing data, and is the core library
 used by samtools and bcftools. HTSlib only depends on zlib. It is known to be
 compatible with gcc, g++ and clang.
 .
 HTSlib implements a generalized BAM (binary SAM) index, with file extension
 ‘csi’ (coordinate-sorted index). The HTSlib file reader first looks for the
 new index and then for the old if the new index is absent.

Package: libhts-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libhts3 (= ${binary:Version}),
         libcurl4-gnutls-dev,
         libdeflate-dev,
         liblzma-dev,
         zlib1g-dev,
         ${misc:Depends}
Description: development files for the HTSlib
 HTSlib is an implementation of a unified C library for accessing common file
 formats, such as SAM (Sequence Alignment/Map), CRAM and VCF (Variant Call
 Format), used for high-throughput sequencing data, and is the core library
 used by samtools and bcftools. HTSlib only depends on zlib. It is known to be
 compatible with gcc, g++ and clang.
 .
 HTSlib implements a generalized BAM (binary SAM) index, with file extension
 ‘csi’ (coordinate-sorted index). The HTSlib file reader first looks for the
 new index and then for the old if the new index is absent.
 .
 This package contains development files for the HTSlib: headers, static
 library, manual pages, etc.
 .
 For compatibility with sambamba, the internal routine cram_to_bam was
 exported, hereto adopting a patch found in guix.

Package: htslib-test
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${perl:Depends}
Breaks: libhts-private-dev
Replaces: libhts-private-dev
Description: Test data for HTSlib
 HTSlib is an implementation of a unified C library for accessing common file
 formats, such as SAM (Sequence Alignment/Map), CRAM and VCF (Variant Call
 Format), used for high-throughput sequencing data, and is the core library
 used by samtools and bcftools. HTSlib only depends on zlib. It is known to be
 compatible with gcc, g++ and clang.
 .
 HTSlib implements a generalized BAM (binary SAM) index, with file extension
 ‘csi’ (coordinate-sorted index). The HTSlib file reader first looks for the
 new index and then for the old if the new index is absent.
 .
 This package contains test files and scripts for the HTSlib.

Package: tabix
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: generic indexer for TAB-delimited genome position files
 Tabix indexes files where some columns indicate sequence coordinates: name
 (usually a chromosome), start and stop. The input data file must be position
 sorted and compressed by bgzip (provided in this package), which has a gzip
 like interface. After indexing, tabix is able to quickly retrieve data lines by
 chromosomal coordinates. Fast data retrieval also works over network if an URI
 is given as a file name.
 .
 This package is built from the HTSlib source, and provides the bgzip, htsfile,
 and tabix tools.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

ifneq (,$(filter $(DEB_HOST_ARCH),i386 kfreebsd-i386 hurd-i386))
  DEB_CFLAGS_MAINT_APPEND=-msse -mfpmath=sse
endif
DEB_CFLAGS_MAINT_APPEND+=-ffat-lto-objects
DEB_LDFLAGS_MAINT_APPEND+=-Wl,-flto -fvisibility=hidden -ffat-lto-objects

export DEB_CFLAGS_MAINT_APPEND
export DEB_LDFLAGS_MAINT_APPEND

# Prune +,ds etc from version
UPSTREAM_VERSION := $(shell echo $(DEB_VERSION_UPSTREAM) | sed 's/+.*//')


%:
	dh $@

hello:
	echo "Upstream version: $(UPSTREAM_VERSION)"

override_dh_auto_configure:
ifneq (,$(filter $(DEB_HOST_ARCH),i386 kfreebsd-i386 hurd-i386))
	cp htslib.pc.in debian/
	cp debian/i386-htslib.pc.in ./htslib.pc.in
endif
	# create clean copy of test dir
	cp -a test test_backup
	# to help with cross building, otherwise MMAP might get turned off
	export ac_cv_func_mmap_fixed_mapped=yes && autoconf && \
	dh_auto_configure -- --enable-libcurl --enable-gcs --enable-s3 --enable-plugins --with-plugin-dir='$(libdir)/htslib' --with-external-htscodecs --with-plugin-path='/usr/local/lib/htslib:/usr/local/libexec/htslib:$(plugindir)'

override_dh_auto_build-arch:
	dh_auto_build -- \
	  CFLAGS="$$(dpkg-buildflags --get CFLAGS)" \
	  CPPFLAGS="-I. -DSAMTOOLS=1 $$(dpkg-buildflags --get CPPFLAGS)" \
	  LDFLAGS="$$(dpkg-buildflags --get LDFLAGS)" \
	  PACKAGE_VERSION="$(UPSTREAM_VERSION)" \
	  libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
# re-try later	  LDLIBS=-lhts \

override_dh_auto_build-indep:

override_dh_auto_install-arch:
	for binary in sam test-regidx hts_endian test-bcf-sr test_bgzf ; do \
	    rm $(CURDIR)/test/$${binary} ; \
	done
	dh_auto_install -- prefix=/usr \
	  CFLAGS="$$(dpkg-buildflags --get CFLAGS)" \
	  CPPFLAGS="-I. -DSAMTOOLS=1 $$(dpkg-buildflags --get CPPFLAGS)" \
	  LDFLAGS="$$(dpkg-buildflags --get LDFLAGS)" \
	  PACKAGE_VERSION="$(UPSTREAM_VERSION)" \
	  libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
	# restore clean copy of test dir before dh_install is run
	# This should not be done earlier since dh_auto_install contains some unconditional removals
	$(RM) -r test
	mv test_backup test

override_dh_strip:
	# This is apparently important for the interpretation by ldc2 in sambamba
	dh_strip -Xlibhts.a

override_dh_auto_install-indep:

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test -- \
	  CFLAGS="$$(dpkg-buildflags --get CFLAGS)" \
	  CPPFLAGS="-I. -DSAMTOOLS=1 $$(dpkg-buildflags --get CPPFLAGS)" \
	  LDFLAGS="$$(dpkg-buildflags --get LDFLAGS)" \
	  PACKAGE_VERSION="$(UPSTREAM_VERSION)" \
	  libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
	  || \
	  if find . -name "FAIL*" > /dev/null ; then \
	    for file in $$(find . -name "FAIL*"); do echo $${file}; cat $${file}; done && false ; \
	  fi
endif

override_dh_auto_test-indep:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	echo "Suppress test for Architecture independant builds."
endif

override_dh_install-indep:
	dh_install --indep
	sed -i 's/-ffile-prefix-map=[^[:space:]]* //g' debian/htslib-test/usr/share/htslib-test/config.mk
	sed -i 's/-fdebug-prefix-map=[^[:space:]]* //g' debian/htslib-test/usr/share/htslib-test/config.mk
	sed -i 's#\.\./\.\./htslib/#htslib/#' `grep -Rl '../../htslib/' debian/htslib-test/*`

override_dh_installdocs:
	dh_installdocs
	# Fix Perl interpreter path
	for pl in `grep -Rl '#!/usr/bin/env[[:space:]]\+perl' debian/*/usr/*` ; do \
	    sed -i '1s?^#!/usr/bin/env[[:space:]]\+perl?#!/usr/bin/perl?' $${pl} ; \
	done

override_dh_installchangelogs:
	dh_installchangelogs NEWS

override_dh_missing:
	# FIXME: No idea why these files are remaining in debian/tmp
	rm -rf debian/tmp/usr/bin debian/tmp/usr/share/man
	dh_missing

override_dh_fixperms:
	dh_fixperms
	find debian -name simple_test_driver.sh -exec chmod +x \{\} \;

override_dh_auto_clean:
ifneq (,$(filter $(DEB_HOST_ARCH),i386 kfreebsd-i386 hurd-i386))
ifneq (,$(wildcard debian/htslib.pc.in))
	cp debian/htslib.pc.in ./
endif
endif
	dh_auto_clean
	rm -rf test_backup/

## htslib 1.17+ds

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Makefile for htslib, a C library for high-throughput sequencing data formats.
 #
-#    Copyright (C) 2013-2022 Genome Research Ltd.
+#    Copyright (C) 2013-2023 Genome Research Ltd.
 #
 #    Author: John Marshall <jm18@sanger.ac.uk>
 #
@@ -39,6 +39,7 @@
 EXTRA_CFLAGS_PIC = -fpic
 TARGET_CFLAGS =
 LDFLAGS  = -fvisibility=hidden
+VERSION_SCRIPT_LDFLAGS = -Wl,-version-script,$(srcprefix)htslib.map
 LIBS     = $(htslib_default_libs)
 
 prefix      = /usr/local
@@ -58,7 +59,8 @@
 INSTALL = install -p
 INSTALL_DATA    = $(INSTALL) -m 644
 INSTALL_DIR     = $(MKDIR_P) -m 755
-INSTALL_LIB     = $(INSTALL_DATA)
+LIB_PERM        = 644
+INSTALL_LIB     = $(INSTALL) -m $(LIB_PERM)
 INSTALL_MAN     = $(INSTALL_DATA)
 INSTALL_PROGRAM = $(INSTALL)
 
@@ -80,6 +82,7 @@
 	test/sam \
 	test/test_bgzf \
 	test/test_expr \
+	test/test_faidx \
 	test/test_kfunc \
 	test/test_kstring \
 	test/test_mod \
@@ -140,8 +143,8 @@
 # is not strictly necessary and should be removed the next time
 # LIBHTS_SOVERSION is bumped (see #1144 and
 # https://developer.apple.com/library/archive/documentation/DeveloperTools/Conceptual/DynamicLibraries/100-Articles/DynamicLibraryDesignGuidelines.html#//apple_ref/doc/uid/TP40002013-SW23)
-MACH_O_COMPATIBILITY_VERSION = 3.1.16
-MACH_O_CURRENT_VERSION = 3.1.16
+MACH_O_COMPATIBILITY_VERSION = 3.1.17
+MACH_O_CURRENT_VERSION = 3.1.17
 
 # $(NUMERIC_VERSION) is for items that must have a numeric X.Y.Z string
 # even if this is a dirty or untagged Git working tree.
@@ -160,12 +163,20 @@
 	@echo PACKAGE_VERSION = $(PACKAGE_VERSION)
 	@echo NUMERIC_VERSION = $(NUMERIC_VERSION)
 
+config_vars.h: override escape=$(subst ',\x27,$(subst ",\",$(subst \,\\,$(1))))
+config_vars.h: override hts_cc_escaped=$(call escape,$(CC))
+config_vars.h: override hts_cppflags_escaped=$(call escape,$(CPPFLAGS))
+config_vars.h: override hts_cflags_escaped=$(call escape,$(CFLAGS))
+config_vars.h: override hts_ldflags_escaped=$(call escape,$(LDFLAGS))
+config_vars.h: override hts_libs_escaped=$(call escape,$(LIBS))
+
 config_vars.h:
-	echo '#define HTS_CC "$(CC)"' > $@
-	echo '#define HTS_CPPFLAGS "$(CPPFLAGS)"' >> $@
-	echo '#define HTS_CFLAGS "$(CFLAGS)"' >> $@
-	echo '#define HTS_LDFLAGS "$(LDFLAGS)"' >> $@
-	echo '#define HTS_LIBS "$(LIBS)"' >> $@
+	printf '#define HTS_CC "%s"\n#define HTS_CPPFLAGS "%s"\n#define HTS_CFLAGS "%s"\n#define HTS_LDFLAGS "%s"\n#define HTS_LIBS "%s"\n' \
+	'$(hts_cc_escaped)' \
+	'$(hts_cppflags_escaped)' \
+	'$(hts_cflags_escaped)' \
+	'$(hts_ldflags_escaped)' \
+	'$(hts_libs_escaped)' > $@
 
 .SUFFIXES: .bundle .c .cygdll .dll .o .pico .so
 
@@ -341,14 +352,3 @@
 # The target here is libhts.so, as that is the built file that other rules
 # depend upon and that is used when -lhts appears in other program's recipes.
 # As a byproduct invisible to make, libhts.so.NN is also created, as it is the
-# file used at runtime (when $LD_LIBRARY_PATH includes the build directory).
-
-libhts.so: $(LIBHTS_OBJS:.o=.pico)
-	$(CC) -shared -Wl,-soname,libhts.so.$(LIBHTS_SOVERSION) $(LDFLAGS) -o $@ $(LIBHTS_OBJS:.o=.pico) $(LIBS) -lpthread
-	ln -sf $@ libhts.so.$(LIBHTS_SOVERSION)
-
-# Similarly this also creates libhts.NN.dylib as a byproduct, so that programs
-# when run can find this uninstalled shared library (when $DYLD_LIBRARY_PATH
-# includes this project's build directory).
-
-libhts.dylib: $(LIBHTS_OBJS)

=== debian/changelog ===
htslib (1.17+ds-1) unstable; urgency=medium

  * Migrate htslib to unstable.
  * d/control: declare libhts3 breaks samtools < 1.17.

 -- Étienne Mollier <emollier@debian.org>  Thu, 22 Jun 2023 22:21:42 +0200

htslib (1.17+ds-0+exp1) experimental; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * d/control: fix indentation in build dependencies
  * d/control: clear fields with obsolete packages
  * Patches triage:
    - no_git_version patch: forwarding not-needed
    - fPIC.patch: unfuzz
    - cram_to_bam_export.patch: unfuzz
    - fix_sequence_of_linked_libs.patch: unfuzz
    - trim-file-prefix.patch: refresh
  * fix-cram-external-header.patch: new patch.
    This fixes a FTBFS caused by a typo in the source code.
  * d/libhts3.symbols: update symbols table.
    Upstream is now tracking symbols versioning.  The change is large with
    numerous missing entries, but that is because of the "@Base" being
    replaced by the versioned "@HTSLIB_*" entries.
  * d/t/run-unit-test: copy htslib.map.
    This file is needed for one of the linking tests done during the
    autopkgtest run, otherwise it fails.
  * fix-whatis-entry.patch: new patch.
    This change fixes a bad whatis(1) entry caught by lintian.

 -- Étienne Mollier <emollier@debian.org>  Sun, 11 Jun 2023 20:10:19 +0200

htslib (1.16+ds-3) unstable; urgency=medium

  * d/rules: make sure libdir and plugindir are defined.
    Thanks to James Bonfield
  * d/libhts3.install: relocate plugins following fix at configure step.
  * d/*.install: remove dh-exec shebang.
  * d/control: remove build-dependency to dh-exec.
  * disable_plugin_loading_test.patch: remove; test is supposed to pass.
  * d/rules: do not erase LDFLAGS; fix the aforementioned test failure
    by restoring -rdynamic flag supposed to be passed to the linker.
  * d/patches/: remove unused patches.
  * trim-file-prefix.patch: add; improve reproducible build.

 -- Étienne Mollier <emollier@debian.org>  Wed, 19 Oct 2022 22:25:57 +0200

## htslib 1.18+ds

=== debian/changelog ===
htslib (1.18+ds-1) unstable; urgency=medium

  * Migrate htslib 1.18 from experimental to unstable.

 -- Étienne Mollier <emollier@debian.org>  Tue, 07 Nov 2023 19:46:30 +0100

htslib (1.18+ds-0+exp1) experimental; urgency=medium

  * New upstream version 1.18+ds
  * testShebang.patch: refresh.
  * fix_float_precision: refresh patch.
  * cram_to_bam_export.patch: refresh.
  * fix_sequence_of_linked_libs.patch: refresh.
  * trim-file-prefix.patch: refresh.
  * fix-cram-external-header.patch: remove: applied upstream.
  * fix-whatis-entry.patch: remove: applied upstream.
  * debian/*.symbols*: introduce new symbols.
  * d/copyright: update upstream copyright year.

 -- Étienne Mollier <emollier@debian.org>  Wed, 23 Aug 2023 18:42:10 +0200

=== debian/control ===
--- 
+++ 
@@ -8,15 +8,14 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
-               dh-exec,
                libbz2-dev,
                libcurl4-gnutls-dev,
                liblzma-dev,
                libssl-dev,
                zlib1g-dev,
-	       libdeflate-dev,
+               libdeflate-dev,
                libhtscodecs-dev (>= 1.0)
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/htslib
 Vcs-Git: https://salsa.debian.org/med-team/htslib.git
 Homepage: https://github.com/samtools/htslib
@@ -29,11 +28,11 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
-Replaces: libhts-dev (<< 1.13~)
 Breaks: libtabixpp (<< 1.0.0-5~),
         libhts-dev (<< 1.13~),
-        samtools (<< 1.13~),
+        samtools (<< 1.17~),
         ivar (<< 1.3.1~)
+Replaces: libhts-dev (<< 1.13~)
 Description: C library for high-throughput sequencing data formats
  HTSlib is an implementation of a unified C library for accessing common file
  formats, such as SAM (Sequence Alignment/Map), CRAM and VCF (Variant Call
@@ -77,8 +76,6 @@
 Multi-Arch: foreign
 Depends: ${misc:Depends},
          ${perl:Depends}
-Breaks: libhts-private-dev
-Replaces: libhts-private-dev
 Description: Test data for HTSlib
  HTSlib is an implementation of a unified C library for accessing common file
  formats, such as SAM (Sequence Alignment/Map), CRAM and VCF (Variant Call

## htslib 1.19+ds

=== debian/changelog ===
htslib (1.19+ds-1.1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:25:58 +0000

htslib (1.19+ds-1.1build2) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:59:31 +0000

htslib (1.19+ds-1.1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 18:12:45 +0000

htslib (1.19+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062344

 -- Lukas Märdian <slyon@debian.org>  Wed, 28 Feb 2024 10:41:39 +0000

htslib (1.19+ds-1) unstable; urgency=medium

  * Migrate htslib 1.19 from experimental to unstable.

 -- Étienne Mollier <emollier@debian.org>  Sat, 17 Feb 2024 11:42:52 +0100

htslib (1.19+ds-0+exp0) experimental; urgency=medium

  * New upstream version 1.19+ds
  * fix_float_precision: refresh patch.
  * fix_sequence_of_linked_libs: refresh patch.
  * trim-file-prefix.patch: refresh.
  * d/libhts3.symbols: remove a recorded symbol(!)
    bgzf_idx_amend_last was recorded by accident and is not part of the
    internals of the htslib anymore.  Reverse dependencies had no way of
    using this function by accident, as it is not part of the public API,
    and preliminary tests against reverse dependencies show no regressions
    seemingly related to the missing symbol.
  * reinject-bgzf_idx_amend_last.patch: unapplied new.
    This patch is kept handy to reintroduce missing bgzf_idx_amend_last
    symbol if need be, but it is not applied yet.

 -- Étienne Mollier <emollier@debian.org>  Fri, 15 Dec 2023 22:25:33 +0100

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: htslib
-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Charles Plessy <plessy@debian.org>,
            Andreas Tille <tille@debian.org>,
            Michael R. Crusoe <crusoe@debian.org>,
@@ -7,7 +8,7 @@
            Étienne Mollier <emollier@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
                libbz2-dev,
                libcurl4-gnutls-dev,
                liblzma-dev,
@@ -21,18 +22,20 @@
 Homepage: https://github.com/samtools/htslib
 Rules-Requires-Root: no
 
-Package: libhts3
+Package: libhts3t64
+Provides: ${t64:Provides}
 Architecture: any
 Multi-Arch: same
 Section: libs
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
-Breaks: libtabixpp (<< 1.0.0-5~),
+Breaks: libhts3 (<< ${source:Version}),
+        libtabixpp (<< 1.0.0-5~),
         libhts-dev (<< 1.13~),
         samtools (<< 1.17~),
         ivar (<< 1.3.1~)
-Replaces: libhts-dev (<< 1.13~)
+Replaces: libhts3, libhts-dev (<< 1.13~)
 Description: C library for high-throughput sequencing data formats
  HTSlib is an implementation of a unified C library for accessing common file
  formats, such as SAM (Sequence Alignment/Map), CRAM and VCF (Variant Call
@@ -48,7 +51,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libhts3 (= ${binary:Version}),
+Depends: libhts3t64 (= ${binary:Version}),
          libcurl4-gnutls-dev,
          libdeflate-dev,
          liblzma-dev,

## htslib 1.20+ds

=== debian/changelog ===
htslib (1.20+ds-1) unstable; urgency=medium

  * New upstream version 1.20+ds
  * d/copyright: update copyright year.
  * d/control: declare compliance to standards version 4.7.0.
  * Patch fix_float_precision: refresh.
  * testShebang.patch: unfuzz.
  * d/libhts3t64.symbols: introduce new upstream functions.

 -- Étienne Mollier <emollier@debian.org>  Wed, 29 May 2024 12:25:07 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: htslib
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
+Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Charles Plessy <plessy@debian.org>,
            Andreas Tille <tille@debian.org>,
            Michael R. Crusoe <crusoe@debian.org>,
@@ -16,7 +15,7 @@
                zlib1g-dev,
                libdeflate-dev,
                libhtscodecs-dev (>= 1.0)
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/htslib
 Vcs-Git: https://salsa.debian.org/med-team/htslib.git
 Homepage: https://github.com/samtools/htslib

## htslib 1.21%2Bds

=== debian/control ===
--- 
+++ 
@@ -50,7 +50,8 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libhts3t64 (= ${binary:Version}),
+Depends: libbz2-dev,
+         libhts3t64 (= ${binary:Version}),
          libcurl4-gnutls-dev,
          libdeflate-dev,
          liblzma-dev,

=== debian/rules ===
--- 
+++ 
@@ -17,6 +17,8 @@
 # Prune +,ds etc from version
 UPSTREAM_VERSION := $(shell echo $(DEB_VERSION_UPSTREAM) | sed 's/+.*//')
 
+libdir = /usr/lib/$(DEB_HOST_MULTIARCH)
+plugindir = $(libdir)/htslib
 
 %:
 	dh $@
@@ -32,16 +34,23 @@
 	# create clean copy of test dir
 	cp -a test test_backup
 	# to help with cross building, otherwise MMAP might get turned off
-	export ac_cv_func_mmap_fixed_mapped=yes && autoconf && \
-	dh_auto_configure -- --enable-libcurl --enable-gcs --enable-s3 --enable-plugins --with-plugin-dir='$(libdir)/htslib' --with-external-htscodecs --with-plugin-path='/usr/local/lib/htslib:/usr/local/libexec/htslib:$(plugindir)'
+	export ac_cv_func_mmap_fixed_mapped=yes \
+	&& autoconf \
+	&& dh_auto_configure -- \
+		--enable-libcurl \
+		--enable-gcs \
+		--enable-s3 \
+		--enable-plugins \
+		--with-plugin-dir='$(libdir)/htslib' \
+		--with-external-htscodecs \
+		--with-plugin-path='/usr/local/lib/htslib:/usr/local/libexec/htslib:$(plugindir)'
 
 override_dh_auto_build-arch:
 	dh_auto_build -- \
 	  CFLAGS="$$(dpkg-buildflags --get CFLAGS)" \
 	  CPPFLAGS="-I. -DSAMTOOLS=1 $$(dpkg-buildflags --get CPPFLAGS)" \
-	  LDFLAGS="$$(dpkg-buildflags --get LDFLAGS)" \
 	  PACKAGE_VERSION="$(UPSTREAM_VERSION)" \
-	  libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
+	  libdir=$(libdir)
 # re-try later	  LDLIBS=-lhts \
 
 override_dh_auto_build-indep:
@@ -53,9 +62,8 @@
 	dh_auto_install -- prefix=/usr \
 	  CFLAGS="$$(dpkg-buildflags --get CFLAGS)" \
 	  CPPFLAGS="-I. -DSAMTOOLS=1 $$(dpkg-buildflags --get CPPFLAGS)" \
-	  LDFLAGS="$$(dpkg-buildflags --get LDFLAGS)" \
 	  PACKAGE_VERSION="$(UPSTREAM_VERSION)" \
-	  libdir=/usr/lib/$(DEB_HOST_MULTIARCH)
+	  libdir=$(libdir)
 	# restore clean copy of test dir before dh_install is run
 	# This should not be done earlier since dh_auto_install contains some unconditional removals
 	$(RM) -r test
@@ -72,9 +80,8 @@
 	dh_auto_test -- \
 	  CFLAGS="$$(dpkg-buildflags --get CFLAGS)" \
 	  CPPFLAGS="-I. -DSAMTOOLS=1 $$(dpkg-buildflags --get CPPFLAGS)" \
-	  LDFLAGS="$$(dpkg-buildflags --get LDFLAGS)" \
 	  PACKAGE_VERSION="$(UPSTREAM_VERSION)" \
-	  libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
+	  libdir=$(libdir) \
 	  || \
 	  if find . -name "FAIL*" > /dev/null ; then \
 	    for file in $$(find . -name "FAIL*"); do echo $${file}; cat $${file}; done && false ; \

## htslib 1.21+ds

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Makefile for htslib, a C library for high-throughput sequencing data formats.
 #
-#    Copyright (C) 2013-2023 Genome Research Ltd.
+#    Copyright (C) 2013-2024 Genome Research Ltd.
 #
 #    Author: John Marshall <jm18@sanger.ac.uk>
 #
@@ -68,6 +68,7 @@
 plugindir =
 
 BUILT_PROGRAMS = \
+	annot-tsv \
 	bgzip \
 	htsfile \
 	tabix
@@ -84,8 +85,10 @@
 	test/test_expr \
 	test/test_faidx \
 	test/test_kfunc \
+	test/test_khash \
 	test/test_kstring \
 	test/test_mod \
+	test/test_nibbles \
 	test/test_realn \
 	test/test-regidx \
 	test/test_str2int \
@@ -110,8 +113,14 @@
 	test/thrash_threads6 \
 	test/thrash_threads7
 
-all: lib-static lib-shared $(BUILT_PROGRAMS) plugins $(BUILT_TEST_PROGRAMS) \
-     htslib_static.mk htslib-uninstalled.pc
+all: lib-static lib-shared $(BUILT_PROGRAMS) plugins \
+	$(BUILT_TEST_PROGRAMS) htslib_static.mk htslib-uninstalled.pc
+
+# Report compiler and version
+cc-version:
+	-@$(CC) --version  2>/dev/null || true
+	-@$(CC) --qversion 2>/dev/null || true
+	-@$(CC) -V         2>/dev/null || true
 
 ALL_CPPFLAGS = -I. $(CPPFLAGS)
 
@@ -126,9 +135,15 @@
 srcprefix =
 HTSPREFIX =
 
+# Flags for SIMD code
 HTS_CFLAGS_AVX2 =
 HTS_CFLAGS_AVX512 =
 HTS_CFLAGS_SSE4 =
+
+# Control building of SIMD code.  Not used if configure has been run.
+HTS_BUILD_AVX2 =
+HTS_BUILD_AVX512 =
+HTS_BUILD_SSE4 =
 
 include htslib_vars.mk
 include htscodecs.mk
@@ -143,12 +158,8 @@
 # is not strictly necessary and should be removed the next time
 # LIBHTS_SOVERSION is bumped (see #1144 and
 # https://developer.apple.com/library/archive/documentation/DeveloperTools/Conceptual/DynamicLibraries/100-Articles/DynamicLibraryDesignGuidelines.html#//apple_ref/doc/uid/TP40002013-SW23)
-MACH_O_COMPATIBILITY_VERSION = 3.1.17
-MACH_O_CURRENT_VERSION = 3.1.17
-
-# $(NUMERIC_VERSION) is for items that must have a numeric X.Y.Z string
-# even if this is a dirty or untagged Git working tree.
-NUMERIC_VERSION := $(shell $(srcdir)/version.sh numeric)
+MACH_O_COMPATIBILITY_VERSION = 3.1.21
+MACH_O_CURRENT_VERSION = 3.1.21
 
 # Force version.h to be remade if $(PACKAGE_VERSION) has changed.
 version.h: $(if $(wildcard version.h),$(if $(findstring "$(PACKAGE_VERSION)",$(shell cat version.h)),,force))
@@ -161,7 +172,6 @@
 
 show-version:
 	@echo PACKAGE_VERSION = $(PACKAGE_VERSION)
-	@echo NUMERIC_VERSION = $(NUMERIC_VERSION)
 
 config_vars.h: override escape=$(subst ',\x27,$(subst ",\",$(subst \,\\,$(1))))
 config_vars.h: override hts_cc_escaped=$(call escape,$(CC))
@@ -206,6 +216,8 @@
 	regidx.o \
 	region.o \
 	sam.o \
+	sam_mods.o \
+	simd.o \
 	synced_bcf_reader.o \
 	vcf_sweep.o \
 	tbx.o \
@@ -243,6 +255,7 @@
 cram_structs_h = cram/cram_structs.h $(htslib_thread_pool_h) $(htslib_cram_h) cram/string_alloc.h cram/mFILE.h $(htslib_khash_h)
 cram_open_trace_file_h = cram/open_trace_file.h cram/mFILE.h
 bcf_sr_sort_h = bcf_sr_sort.h $(htslib_synced_bcf_reader_h) $(htslib_kbitset_h)
+fuzz_settings_h = fuzz_settings.h
 header_h = header.h cram/string_alloc.h cram/pooled_alloc.h $(htslib_khash_h) $(htslib_kstring_h) $(htslib_sam_h)
 hfile_internal_h = hfile_internal.h $(htslib_hts_defs_h) $(htslib_hfile_h) $(textutils_internal_h)
 hts_internal_h = hts_internal.h $(htslib_hts_h) $(textutils_internal_h)
@@ -274,7 +287,11 @@
 	echo '#endif' >> $@
 	echo '#define HAVE_DRAND48 1' >> $@
 	echo '#define HAVE_LIBCURL 1' >> $@
-	if [ "x$(HTS_CFLAGS_SSE4)" != "x" ] ; then \
+	if [ "x$(HTS_HAVE_CPUID)" != "x" ]; then \
+	    echo '#define HAVE_DECL___CPUID_COUNT 1' >> $@ ; \
+	    echo '#define HAVE_DECL___GET_CPUID_MAX 1' >> $@ ; \
+	fi
+	if [ "x$(HTS_BUILD_SSE4)" != "x" ]; then \
 	    echo '#define HAVE_POPCNT 1' >> $@ ; \
 	    echo '#define HAVE_SSE4_1 1' >> $@ ; \
 	    echo '#define HAVE_SSSE3 1' >> $@ ; \
@@ -282,12 +299,19 @@
 	    echo '#define UBSAN 1' >> $@ ; \
 	    echo '#endif' >> $@ ; \
 	fi
-	if [ "x$(HTS_CFLAGS_AVX2)" != "x" ] ; then \
+	if [ "x$(HTS_BUILD_AVX2)" != "x" ] ; then \
 	    echo '#define HAVE_AVX2 1' >> $@ ; \
 	fi
-	if [ "x$(HTS_CFLAGS_AVX512)" != "x" ] ; then \
+	if [ "x$(HTS_BUILD_AVX512)" != "x" ] ; then \
 	    echo '#define HAVE_AVX512 1' >> $@ ; \
 	fi
+	echo '#if defined __x86_64__ || defined __arm__ || defined __aarch64__' >> $@
+	echo '#define HAVE_ATTRIBUTE_CONSTRUCTOR 1' >> $@
+	echo '#endif' >> $@
+	echo '#if (defined(__x86_64__) || defined(_M_X64))' >> $@
+	echo '#define HAVE_ATTRIBUTE_TARGET 1' >> $@
+	echo '#define HAVE_BUILTIN_CPU_SUPPORT_SSSE3 1' >> $@
+	echo '#endif' >> $@
 
 # And similarly for htslib.pc.tmp ("pkg-config template").  No dependency
 # on htslib.pc.in listed, as if that file is newer the usual way to regenerate
@@ -331,24 +355,3 @@
 ifneq "$(BUILT_PLUGINS)" ""
 plugins: lib-shared
 endif
-plugins: $(BUILT_PLUGINS)
-
-
-libhts.a: $(LIBHTS_OBJS)
-	@-rm -f $@
-	$(AR) -rc $@ $(LIBHTS_OBJS)
-	-$(RANLIB) $@
-
-print-config:
-	@echo HTS_CFLAGS_AVX2 = $(HTS_CFLAGS_AVX2)
-	@echo HTS_CFLAGS_AVX512 = $(HTS_CFLAGS_AVX512)
-	@echo HTS_CFLAGS_SSE4 = $(HTS_CFLAGS_SSE4)
-	@echo HTS_HAVE_NEON = $(HTS_HAVE_NEON)
-	@echo LDFLAGS = $(LDFLAGS)
-	@echo LIBHTS_OBJS = $(LIBHTS_OBJS)
-	@echo LIBS = $(LIBS)
-	@echo PLATFORM = $(PLATFORM)
-
-# The target here is libhts.so, as that is the built file that other rules
-# depend upon and that is used when -lhts appears in other program's recipes.
-# As a byproduct invisible to make, libhts.so.NN is also created, as it is the

=== samples/Makefile ===
HTS_DIR = ../
include $(HTS_DIR)/htslib_static.mk

CC = gcc
CFLAGS = -Wall -O2

#to statically link to libhts
LDFLAGS = $(HTS_DIR)/libhts.a -L$(HTS_DIR) $(HTSLIB_static_LDFLAGS) $(HTSLIB_static_LIBS)

#to dynamically link to libhts
#LDFLAGS = -L $(HTS_DIR) -lhts -Wl,-rpath,<installed lib path>

PRGS = flags split split2 cram read_fast read_header read_ref read_bam \
	read_aux dump_aux add_header rem_header update_header mod_bam mod_aux \
	mod_aux_ba write_fast idx_on_write read_reg read_multireg pileup \
	mpileup modstate pileup_mod flags_field split_t1 split_t2 \
	read_fast_i qtask_ordered qtask_unordered index_fasta

all: $(PRGS)

flags: flags_demo.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) flags_demo.c -o $@  $(LDFLAGS)

split: split.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) split.c -o $@  $(LDFLAGS)

split2: split2.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) split2.c -o $@  $(LDFLAGS)

cram: cram.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) cram.c -o $@  $(LDFLAGS)

read_fast: read_fast.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) read_fast.c -o $@  $(LDFLAGS)

read_header: read_header.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) read_header.c -o $@  $(LDFLAGS)

read_ref: read_refname.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) read_refname.c -o $@  $(LDFLAGS)

read_bam: read_bam.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) read_bam.c -o $@  $(LDFLAGS)

read_aux: read_aux.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) read_aux.c -o $@  $(LDFLAGS)

dump_aux: dump_aux.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) dump_aux.c -o $@  $(LDFLAGS)

add_header: add_header.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) add_header.c -o $@  $(LDFLAGS)

rem_header: rem_header.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) rem_header.c -o $@  $(LDFLAGS)

update_header: update_header.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) update_header.c -o $@  $(LDFLAGS)

mod_bam: mod_bam.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) mod_bam.c -o $@  $(LDFLAGS)

mod_aux: mod_aux.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) mod_aux.c -o $@  $(LDFLAGS)

mod_aux_ba: mod_aux_ba.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) mod_aux_ba.c -o $@  $(LDFLAGS)

write_fast: write_fast.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) write_fast.c -o $@  $(LDFLAGS)

idx_on_write: index_write.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) index_write.c -o $@  $(LDFLAGS)

read_reg: index_reg_read.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) index_reg_read.c -o $@  $(LDFLAGS)

read_multireg: index_multireg_read.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) index_multireg_read.c -o $@  $(LDFLAGS)

read_fast_i: read_fast_index.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) read_fast_index.c -o $@  $(LDFLAGS)

pileup: pileup.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) pileup.c -o $@  $(LDFLAGS)

mpileup: mpileup.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) mpileup.c -o $@  $(LDFLAGS)

modstate: modstate.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) modstate.c -o $@  $(LDFLAGS)

pileup_mod: pileup_mod.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) pileup_mod.c -o $@  $(LDFLAGS)

flags_field: flags_htsopt_field.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) flags_htsopt_field.c -o $@  $(LDFLAGS)

split_t1: split_thread1.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) split_thread1.c -o $@  $(LDFLAGS)

split_t2: split_thread2.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) split_thread2.c -o $@  $(LDFLAGS)

index_fasta: index_fasta.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) index_fasta.c -o $@  $(LDFLAGS)

qtask_ordered: qtask_ordered.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) qtask_ordered.c -o $@  $(LDFLAGS)

qtask_unordered: qtask_unordered.c
	$(CC) $(CFLAGS) -I $(HTS_DIR) qtask_unordered.c -o $@  $(LDFLAGS)

clean:
	find . -name "*.o" | xargs rm -rf
	find . -name "*.dSYM" | xargs rm -rf
	-rm -f $(PRGS)

=== debian/changelog ===
htslib (1.21+ds-1) unstable; urgency=medium

  * Migrate htslib 1.21 from experimental to unstable.

 -- Étienne Mollier <emollier@debian.org>  Thu, 06 Feb 2025 21:23:41 +0100

htslib (1.21+ds-0+exp2) experimental; urgency=medium

  * d/libhts3t64.symbols: htslib_nibble2base is architecture specific.
    This symbol is an alternative function to nibble2base_default when
    SSSE3 or NEON vector instructions are available, limiting the set of
    supported architectures to a peculiar set.  Updating the symbol table
    so it matches exposed list on architectures that do not support the
    accelerated symbol.

 -- Étienne Mollier <emollier@debian.org>  Wed, 13 Nov 2024 20:47:53 +0100

htslib (1.21+ds-0+exp1) experimental; urgency=medium

  * New upstream version 1.21+ds
  * cram_to_bam_export.patch: delete: upstream exposed cram_to_bam.
    Note that cram_to_bam is an internal symbol that should not be used
    in normal situations.
  * d/patches/*: unfuzz patches.
  * d/libhts3t64.symbols: record newly introduced symbols.
  * fix_sequence_of_linked_libs.patch: normalise Last-Update.
  * d/libhts3t64.lintian-overrides: delete.
    package-name-doesnt-match-sonames was now an unused override.
  * d/htslib-test.lintian-overrides: flag false positive documentation.
  * d/libhts-dev.lintian-overrides: new.
    Hide the unstripped-static-library affecting libhts.a.  A comment in
    d/rules suggests symbols are needed by reverse dependency sambamba.

 -- Étienne Mollier <emollier@debian.org>  Tue, 12 Nov 2024 23:06:44 +0100

htslib (1.20+ds-2) unstable; urgency=medium

  * Team upload.
  * d/control: libhts-dev: Add missing dependency on libbz2-dev.
    Closes: #1086367, #1086368.

 -- Santiago Vila <sanvila@debian.org>  Thu, 31 Oct 2024 18:32:00 +0100
